from PyQt4.QtCore import *
from PyQt4.QtGui import *
 
import ui_mainwindow
 
class MainWindow(QMainWindow,  ui_mainwindow.Ui_MainWindow):
   def __init__(self, parent):
      super(MainWindow,  self).__init__(parent)
      self.setupUi(self)
 
      maxSize = QSize()
      for i in range(self.listWidget.count()):
         itemSize = QStyledItemDelegate().sizeHint( self.listWidget.viewOptions(), self.listWidget.indexFromItem(self.listWidget.item(i)) )
 
         if itemSize.width() > maxSize.width():
            maxSize.setWidth(itemSize.width())
         if itemSize.height() > maxSize.height():
            maxSize.setHeight(itemSize.height())
 
      maxSize.setWidth(maxSize.width() + 5) # Just some spacing
 
      for i in range(self.listWidget.count()):
         self.listWidget.item(i).setSizeHint(maxSize)
 
      self.listWidget.setGridSize(maxSize)
      self.listWidget.setMaximumWidth(maxSize.width() + self.listWidget.rect().width() - self.listWidget.contentsRect().width() )
      self.listWidget.setMinimumWidth(maxSize.width() + self.listWidget.rect().width() - self.listWidget.contentsRect().width() )
 
      self.show()
 
app = QApplication([])
w = MainWindow(None)
app.exec_()
